local invulncolors = {SKINCOLOR_RED,SKINCOLOR_FLAME,SKINCOLOR_ORANGE,SKINCOLOR_YELLOW,SKINCOLOR_PERIDOT,SKINCOLOR_GREEN,SKINCOLOR_EMERALD,SKINCOLOR_AQUA,SKINCOLOR_CYAN,SKINCOLOR_SAPPHIRE,SKINCOLOR_BLUE,SKINCOLOR_VAPOR,SKINCOLOR_PURPLE,SKINCOLOR_VIOLET,SKINCOLOR_ROSY}

addHook("PlayerThink", function(player)
	if player.mo.invuln_refresh == nil then
		player.mo.invuln_refresh = 1
	else
		if player.mo.invuln_refresh == #invulncolors then
			player.mo.invuln_refresh = 1
		else
			player.mo.invuln_refresh = $ + 1
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.powers[pw_invulnerability] > 0 then
			if player.powers[pw_invulnerability] > 1 then
				player.mo.colorized = true
				player.mo.color = invulncolors[player.mo.invuln_refresh]
			else
				player.mo.colorized = false
				player.mo.color = player.skincolor
			end
			local ghost = P_SpawnGhostMobj(player.mo)
			ghost.colorized = true
			ghost.color = player.mo.color
			ghost.frame = $|FF_ADD
			ghost.renderflags = player.mo.renderflags
		end
	end
end)